[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)
![GitHub tag (latest SemVer)](https://img.shields.io/github/tag/carla-simulator/scenario_runner.svg)
[![Build Status](https://travis-ci.com/carla-simulator/scenario_runner.svg?branch=master)](https://travis-ci.com/carla/scenario_runner)

# ScenarioRunner

ScenarioRunner is a module that allows traffic scenario definition and execution for the [CARLA](http://carla.org/ ) simulator. The scenarios can be defined through a Python interface or using the [OpenSCENARIO](http://www.openscenario.org/) standard.  
  
ScenarioRunner can also be used to prepare AD agents for their evaluation, by easily creating complex traffic scenarios and routes for the agents to navigate through. These results can be validated and shared in the [CARLA Leaderboard](https://leaderboard.carla.org/), an open platform for the community to fairly compare their progress, evaluating agents in realistic traffic situatoins.


The CARLA forum has a specific section regarding ScenarioRunner, for users to post any doubts or suggestions that may arise during the reading of this documentation.  
<div class="build-buttons">
<a href="https://forum.carla.org/" target="_blank" class="btn btn-neutral" title="Go to the latest CARLA release">
CARLA forum</a>
</div>

---

## Quick start
  <p style="padding-left:30px;line-height:1.8">
    [__Get ScenarioRunner__](getting_scenariorunner.md)
        — Tutorial on how to download and launch ScenarioRunner.  
    [__First steps__](getting_started.md)
        — Brief tutorials on how to run different types of scenarios.  
    [__Create a new scenario__](creating_new_scenario.md)
        — Tutorial on how to create a new scenario using ScenarioRunner.  
    [__Metrics module__](metrics_module.md)
        — Explanation of the metrics module.  
    [__F.A.Q.__](FAQ.md)
        — Some of the most frequent installation issues.  
    [__Release notes__](CHANGELOG.md)
        — Features, fixes and other changes listed per release.  
  </p>

## References
  <p style="padding-left:30px;line-height:1.8">
    [__List of scenarios__](list_of_scenarios.md)
        — Example scenarios available in ScenarioRunner.  
    [__OpenScenario support__](getting_started.md)
        — Support status of OpenSCENARIO features.  
  </p>

## Contributing
  <p style="padding-left:30px;line-height:1.8">
    [__Code of conduct__](CODE_OF_CONDUCT.md)
        — Standard rights and duties for contributors.
    [__Coding standard__](coding_standard.md)
        — Guidelines to write proper code.  
    [__Contribution guidelines__](CONTRIBUTING.md)
        — The different ways to contribute to ScenarioRunner.
  </p>

